<?php
namespace app\api\logic;

use app\common\model\AppointmentModel;
use app\common\model\UserModel;

class AppointmentLogic
{
    public function newinfo($arr)
    {
        $fillfields = ['userid', 'kind', 'kind_title'];
        foreach ($fillfields as $key => $value) {
            if (!isset($arr[$value]) || empty($arr[$value])) {
                return backarr(0, "参数缺少");
            }
        }
        $userid = $arr['userid'];
        $kind = $arr['kind'];
        $kind_title = $arr['kind_title'];
        $m_u = new UserModel();
        $m_a = new AppointmentModel();
        $uwhere = ['id' => $userid];
        $uinfo = $m_u->getInfo($uwhere);
        if (empty($uinfo)) {
            return backarr(0, "无用户数据");
        }
        $insertData = $arr;
        $aid = $m_a->insertData($insertData);
        if (empty($aid)) {
            return backarr(0, "操作失败");
        }
        return backarr(1, "操作成功", ['aid' => $aid]);
    }
    /**
     * 获取列表
     *
     * @return void
     * @author wj
     * @date 2022-10-13
     */
    public function getlist($arr)
    {
        $userid = isset($arr['userid']) && is_numeric($arr['userid']) && !empty($arr['userid']) && $arr['userid'] > 0 ? $arr['userid'] : 0;
        $page = isset($arr['page']) && is_numeric($arr['page']) && !empty($arr['page']) && $arr['page'] > 0 ? $arr['page'] : 1;
        $size = isset($arr['size']) && is_numeric($arr['size']) && !empty($arr['size']) && $arr['size'] > 0 ? $arr['size'] : 10;
        $where = [];
        if (!empty($userid)) {
            $where['userid'] = $userid;
        }
        $m_a = new AppointmentModel();
        $count = $m_a->getlistjoinuser($where, 'count');
        if ($count <= 0) {
            return backarr(0, "无数据");
        }
        $totalpage = ceil($count / $size);
        $page > $totalpage && $page = $totalpage;
        $list = $m_a->getlistjoinuser($where, ['a.*', 'u.phone'], $page, $size, 'a.id desc');
        return backarr(1, "查询成功", $list);
    }
}
