<?php
namespace app\common\model;

use think\Model;

class AppointmentModel extends Model
{
    protected $table = "t_appointment";

    public function insertData($data)
    {
        if (!isset($data['create_time']) || empty($data['create_time']) || !is_string($data['create_time'])) {
            $data['create_time'] = date("Y-m-d H:i:s");
        }
        if (isset($data['id'])) {
            unset($data['id']);
        }
        $data = $this->formatData($data);
        if (empty($data)) {
            return false;
        }
        $id = $this->insertGetId($data);
        return $id ? $id : false;
    }

    /**
     * 校验入库数据
     * 20220119
     */
    private function formatData($data)
    {
        $useData = [];
        $fields = $this->getTableFields();
        foreach ($data as $key => $value) {
            if (in_array($key, $fields)) {
                $useData[$key] = $value;
            }
        }
        return $useData;
    }
    public function getInfo($where, $field = "*", $row = true)
    {
        $info = $this->field($field)->where($where);
        if ($row) {
            $info = $info->find();
        } else {
            $info = $info->select();
        }
        return empty($info) ? false : $info;
    }

    public function updateinfo($where, $updateData)
    {
        $row = $this->where($where)->update($updateData);
        return empty($row) ? false : $row;
    }

    public function deleteinfo($where)
    {
        $row = $this->where($where)->delete();
        return empty($row) ? false : $row;
    }

    public function getList($where = [], $field = "*", $page = 1, $size = 10, $order = "id desc", $group = "", $row = false)
    {
        $sqlObj = $this->where($where);
        if ("count" != $field) {
            if (empty($size)) {
                $sqlObj = $sqlObj->field($field)->order($order)->group($group)->page($page, $size);
            } else {
                $sqlObj = $sqlObj->field($field)->order($order)->group($group);
            }
            if ($row) {
                $data = $sqlObj->find();
            } else {
                $data = $sqlObj->select();
            }
        } else {
            $data = $sqlObj = $sqlObj->count();
        }
        return $data;
    }
    /**
     * 获取列表joinuser
     *
     * @return void
     * @author wj
     * @date 2022-10-13
     */
    public function getlistjoinuser($where = [], $field = "*", $page = 1, $size = 10, $order = "", $group = "", $row = false)
    {
        $sqlObj = $this->where($where);
        $sqlObj = $sqlObj->alias('a')->join('t_user u', 'u.id = a.userid');
        if ("count" != $field) {
            if (empty($size)) {
                $sqlObj = $sqlObj->field($field)->order($order)->group($group)->page($page, $size);
            } else {
                $sqlObj = $sqlObj->field($field)->order($order)->group($group);
            }
            if ($row) {
                $data = $sqlObj->find();
            } else {
                $data = $sqlObj->select();
            }
        } else {
            $data = $sqlObj = $sqlObj->count();
        }
        return $data;
    }
}
